image: node:12-alpine

stages:
  # - build
  # - lint
  # - tests
  - deploy

# cache:
#   paths:
#     # - node_modules/
#     - src/.next/

# build:
#   stage: build
#   only:
#     - branches
#     - develop
#   except:
#     - master
#   script:
#     - yarn install
#     - yarn run build

# build_prod:
#   stage: build
#   only:
#     - master
#   script:
#     - echo "BASE_API_URL=$BASE_API_URL" > .env
#     - yarn install
#     - yarn run build

# lint:
#   stage: lint
#   script:
#     - yarn install
#     - yarn run lint

# tests:
#   stage: tests
#   before_script:
#     - yarn install
#   script:
#     - npm run test:ci
#   artifacts:
#     paths:
#       - coverage/

# deploy_staging:
#   stage: deploy
#   image: jfloff/alpine-python
#   only:
#     - develop
#   before_script:
#     - apk update && apk add nodejs npm libressl-dev musl-dev libffi-dev
#     - npm install -g yarn
#     - yarn install --ignore-engines
#     - yarn run build
#     - npm prune --production
#     - pip install awscli --upgrade --user
#     - pip install awsebcli --upgrade --user
#     - export PATH=$PATH:$HOME/.local/bin
#     - aws --profile default configure set aws_access_key_id "$AWS_ACCESS_KEY_ID"
#     - aws --profile default configure set aws_secret_access_key "$AWS_SECRET_ACCESS_KEY"
#     - aws --profile default configure set region us-east-1
#   script:
#     - eb use front-staging
#     - eb deploy front-staging

deploy_staging:
  stage: deploy
  image: amaysim/serverless:1.74.1

  only:
    - develop
    - serverless
  before_script:
    - yarn add global @sls-next/next-aws-cloudfront
    - yarn add @sls-next/next-aws-cloudfront
    - yarn install --ignore-engines
  script:
    - echo "BASE_API_URL=$BASE_API_URL" >> .env
    - cp .env deploys/staging
    - cd deploys/staging
    - serverless

deploy_prod:
  stage: deploy
  image: amaysim/serverless:1.74.1
  only:
    - master
  before_script:
    - yarn add global @sls-next/next-aws-cloudfront
    - yarn add @sls-next/next-aws-cloudfront
    - yarn install --ignore-engines
  script:
    - echo "BASE_API_URL=$BASE_API_URL" >> .env
    - cp .env deploys/production
    - cd deploys/production
    - serverless

# deploy_prod:
#   stage: deploy
#   image: jfloff/alpine-python
#   only:
#     - master
#   before_script:
#     - apk update && apk add nodejs npm libressl-dev musl-dev libffi-dev
#     - npm install -g yarn
#     - yarn install --ignore-engines
#     - yarn run build
#     - npm prune --production
#     - pip install awscli --upgrade --user
#     - pip install awsebcli --upgrade --user
#     - export PATH=$PATH:$HOME/.local/bin
#     - aws --profile default configure set aws_access_key_id "$AWS_ACCESS_KEY_ID"
#     - aws --profile default configure set aws_secret_access_key "$AWS_SECRET_ACCESS_KEY"
#     - aws --profile default configure set region us-east-1
#   script:
#     - eb use front-prod
#     - eb deploy front-prod
